$kind=$args[0]
$prepare=$args[1]
$optimisepdf=[Environment]::GetEnvironmentVariable('optimisepdf')
if ($kind.length -gt 1 -and $kind.substring(0,1) -ne '-') {
  $kind='-'+$kind
}
echo "kind=$kind;"
echo "prepare=$prepare;"

# if Acrobat is working, wait for stop
  if((get-process -Name Acrobat -ea Silentlycontinue) -ne $null){ get-process -Name Acrobat | wait-process }

if ($prepare -eq 1) {
 echo "Write-Host `"Checking for mtx->pmx->musixtex Nuty spiewnikowe preprocessing...`" -NoNewLine" > .\waitmtxspiewnik.ps1
 echo "if((get-process -Id $PID -ea Silentlycontinue) -ne `$null){ Write-Host `" waiting...`" -NoNewLine;wait-process -ID $PID;Write-Host `" ready`"}else{Write-Host `" ready`"}" >> .\waitmtxspiewnik.ps1
 
 echo "Nuty spiewnikowe: sprawdzamy zakonczenie budowy liturg mtx/p-mx"
 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe: wait for liturg mtx/p-mx build end"
 while(!(Test-Path "liturgmtxpmx.done" -PathType Leaf)){sleep 5}
 echo "liturg mtx/p-mx zrobiony"

 $pmx = New-Object System.Threading.Mutex($false, "MtxPmxMutex")
 $host.ui.RawUI.WindowTitle = "Wait for mtx->pmx->musixtex of Nuty on Mutex"
   If ($pmx.WaitOne(86400000)) {
     $host.ui.RawUI.WindowTitle = "mtx->pmx->musixtex Nuty spiewnikowe preprocessing"
     echo ".\prepares.bat spiewnik.tex"
     start -wait -NoNewWindow .\prepares.bat spiewnik.tex
     New-Item -ea SilentlyContinue spiewnikmtxpmx.done
     [void]$pmx.ReleaseMutex()
   } else {
     echo "M-tx/PMX Mutex przeterminowany"
     pause
   }
 $pmx.Dispose()
 exit
}
if(Test-Path .\waitmtxspiewnik.ps1 -PathType Leaf){
  start -wait powershell .\waitmtxspiewnik.ps1
}

echo "Nuty spiewnikowe: sprawdzamy zakonczenie budowy SP$kind.pdf"
$host.ui.RawUI.WindowTitle = "Nuty spiewnikowe: wait for SP$kind.pdf build end"
while(!(Test-Path "..\SP$kind.done" -PathType Leaf)){sleep 5}
echo "SP$kind.pdf zrobiony"

echo "Nuty spiewnikowe: sprawdzamy zakonczenie budowy liturg$kind.pdf"
$host.ui.RawUI.WindowTitle = "Nuty spiewnikowe: wait for liturg$kind.pdf build end"
while(!(Test-Path "liturg$kind.done" -PathType Leaf)){sleep 5}
echo "liturg$kind.pdf zrobiony"

echo "Nuty spiewnikowe: sprawdzamy zakonczenie budowy spiewnik mtx/p-mx"
$host.ui.RawUI.WindowTitle = "Nuty spiewnikowe: wait for spiewnik mtx/p-mx build end"
while(!(Test-Path "spiewnikmtxpmx.done" -PathType Leaf)){sleep 5}
echo "spiewnik mtx/p-mx zrobiony"

if ($kind -eq $null -or $kind -eq "") {
 if(test-path spiewnik.aux){ del spiewnik.aux }
 if(test-path spiewnik.log){ del spiewnik.log }
 if(test-path spiewnik.mx1){ del spiewnik.mx1 }
 if(test-path spiewnik.mx2){ del spiewnik.mx2 }
 if(test-path spiewnik.out){ del spiewnik.out }
 if(test-path spiewnik.pdf){ del spiewnik.pdf }
 if(test-path spiewnik.toc){ del spiewnik.toc }

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe first pass"
 echo "lualatex.exe -synctex=1 -interaction=nonstopmode spiewnik.tex"
 lualatex.exe -synctex=1 -interaction=nonstopmode spiewnik.tex

 echo "musixflx.exe spiewnik.mx1"
 musixflx.exe spiewnik.mx1
 echo ".\sortix spiewnik"
 .\sortix spiewnik

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe second pass"
 echo "lualatex.exe -synctex=1 -interaction=nonstopmode spiewnik.tex"
 lualatex.exe -synctex=1 -interaction=nonstopmode spiewnik.tex

 echo "musixflx.exe spiewnik.mx1"
 musixflx.exe spiewnik.mx1
 echo ".\sortix spiewnik"
 .\sortix spiewnik

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe third pass"
 echo "lualatex.exe -synctex=1 spiewnik.tex"
 lualatex.exe -synctex=1 spiewnik.tex

 if($optimisepdf -and $optimisepdf -eq 1){
   $mtx = New-Object System.Threading.Mutex($false, "AcrobatOptimizationMutex")
   $host.ui.RawUI.WindowTitle = "Wait for Nuty spiewnikowe optimization on Mutex"
    If ($mtx.WaitOne(86400000)) {
      $host.ui.RawUI.WindowTitle = "optimization of spiewnik.pdf"
      echo "Optymalizacja Nut spiewow neokatechumenalnych"
      $Optimizer = Start-Process -Wait -FilePath ".\autohotkey.ahk" -ArgumentList "spiewnik.pdf" -passthru
#      Wait-Process -InputObject $Optimizer -ea Silentlycontinue
      sleep 5
      $Optimizer = Get-Process -name Acrobat -ea Silentlycontinue
      if($Optimizer -ne $null){Wait-Process -InputObject $Optimizer -ErrorAction SilentlyContinue}
      echo "Koniec optymalizacji spiewnik.pdf"
      $host.ui.RawUI.WindowTitle = "optimization of spiewnik.pdf ended"
      [void]$mtx.ReleaseMutex()
    } else {
      echo "AcrobatOptimizationMutex przeterminowany"
      pause
    }
   $mtx.Dispose()
 }
 New-Item -ea SilentlyContinue spiewnik.done
} else {
 if(test-path spiewnik$kind.aux){ del spiewnik$kind.aux }
 if(test-path spiewnik$kind.log){ del spiewnik$kind.log }
 if(test-path spiewnik$kind.mx1){ del spiewnik$kind.mx1 }
 if(test-path spiewnik$kind.mx2){ del spiewnik$kind.mx2 }
 if(test-path spiewnik$kind.out){ del spiewnik$kind.out }
 if(test-path spiewnik$kind.pdf){ del spiewnik$kind.pdf }
 if(test-path spiewnik$kind.toc){ del spiewnik$kind.toc }

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe $kind first pass"
 echo "lualatex.exe -synctex=1 -interaction=nonstopmode --jobname=spiewnik$kind spiewnik.tex"
 lualatex.exe -synctex=1 -interaction=nonstopmode --jobname=spiewnik$kind spiewnik.tex

 echo "musixflx.exe spiewnik$kind.mx1"
 musixflx.exe spiewnik$kind.mx1
 echo ".\sortix spiewnik$kind"
 .\sortix spiewnik$kind

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe $kind second pass"
 echo "lualatex.exe -synctex=1 -interaction=nonstopmode --jobname=spiewnik$kind spiewnik.tex"
 lualatex.exe -synctex=1 -interaction=nonstopmode --jobname=spiewnik$kind spiewnik.tex

 echo "musixflx.exe spiewnik$kind.mx1"
 musixflx.exe spiewnik$kind.mx1
 echo ".\sortix spiewnik$kind"
 .\sortix spiewnik$kind

 $host.ui.RawUI.WindowTitle = "Nuty spiewnikowe $kind third pass"
 echo "lualatex.exe -synctex=1 --jobname=spiewnik$kind spiewnik.tex"
 lualatex.exe -synctex=1 --jobname=spiewnik$kind spiewnik.tex

 if($optimisepdf -and $optimisepdf -eq 1){
   $mtx = New-Object System.Threading.Mutex($false, "AcrobatOptimizationMutex")
   $host.ui.RawUI.WindowTitle = "Wait for Nuty spiewnikowe $kind optimization on Mutex"
    If ($mtx.WaitOne(86400000)) {
      $host.ui.RawUI.WindowTitle = "optimization of spiewnik$kind.pdf"
      echo "Optymalizacja Nut spiewow neokatechumenalnych $kind"
      $Optimizer = Start-Process -Wait -FilePath ".\autohotkey.ahk" -ArgumentList "spiewnik$kind.pdf" -passthru
      sleep 5
      $Optimizer = Get-Process -name Acrobat -ea Silentlycontinue
      if($Optimizer -ne $null){Wait-Process -InputObject $Optimizer -ErrorAction SilentlyContinue}
      echo "Koniec optymalizacji spiewnik$kind.pdf"
      $host.ui.RawUI.WindowTitle = "optimization of spiewnik$kind.pdf ended"
      [void]$mtx.ReleaseMutex()
    } else {
      echo "AcrobatOptimizationMutex przeterminowany"
      pause
    }
   $mtx.Dispose()
 }
 New-Item -ea SilentlyContinue spiewnik$kind.done
}

exit